	; test tool to park harddisks with BIOS help

	org 100h

start:	mov ah,9
	mov dx,msgask
	int 21h
	xor ax,ax
	int 16h
	cmp al,13	; Enter?
	jz doit		; confirmed
	cmp al,27	; ESC?
	jnz start	; ask again


itest:	mov ax,0082h
	mov cx,8765h
	mov dx,0cba9h
	push es
	int 4fh
	pop es
	mov dx,ataspimsg
	cmp cx,9abch
	jz ataspi
	mov dx,noataspimsg
ataspi:	mov ah,9
	int 21h

	mov ax,8200h
	mov cx,8765h
	mov dx,0cba9h
	push es
	int 4fh
	pop es
	mov dx,cammsg
	cmp cx,9abch
	jz cam
	mov dx,nocammsg
cam:	mov ah,9
	int 21h
	mov ax,4c01h
	int 21h



doit:	mov ah,9
	mov dx,msg19
	int 21h
	mov ah,19h	; classic PARK function, will spin down
	mov dl,80h	; some newer harddisks. For Future Domain
	int 13h		; SCSI, this resets the disk and reports the
	call showCY	; disk size in CX DX...
	mov ah,19h
	mov dl,81h
	int 13h
	call showCY
	mov ah,9
	mov dx,msgkey
	int 21h
	xor ax,ax
	int 16h

	mov ah,9
	mov dx,msg55
	int 21h
	mov ax,5505h	; Seagate SCSI start/stop (unpark/park) command
	mov dx,0080h	; dh=1 to unpark
	int 13h
	call showCY
	mov ax,5505h
	mov dx,0081h
	int 13h
	call showCY
	mov ah,9
	mov dx,msgkey
	int 21h
	xor ax,ax
	int 16h

	mov ah,9
	mov dx,msg12
	int 21h
	mov ax,1201h	; al=0 to start, 1 to stop: SyQuest and
	xor cx,cx	; Future Domain (AL, CX only for SyQuest)
	mov dx,0080h	; cx=1 is "do not wait until done"
	int 13h		; (controller RAM test on PS/2 and older)
	call showCY
	mov ax,1201h
	xor cx,cx
	mov dx,0081h
	int 13h
	call showCY
	mov ah,9
	mov dx,msgdone
	int 21h

	mov ax,4c00h
	int 21h

noataspimsg	db "No "
ataspimsg	db "ATASPI interface on int 4f.008x present",13,10,"$"
nocammsg	db "No "
cammsg		db "CAM SCSI interface on int 4f.8x00 present",13,10,"$"

msgask	db "Going to test some disk spin down methods now.",13,10
	db "Every test is done for disk 0x80 and disk 0x81.",13,10
	db "Press enter to continue or escape to abort...",13,10
	db "If you abort, ATASPI / CAM install check is done.",13,10,"$"
msgdone	db "Done. Please report which tests succeeded.",13,10
	db "Status codes: 0 okay, 1 invalid function, 80 timeout...",13,10
	db "If you get status 19, 55 or 12 for the same-numbered",13,10
	db "tests, then the BIOS probably ignored the request.",13,10,"$"
msgkey	db "Press a key to try the next method",13,10,"$"

msg19	db "Testing int 13.19 classic PARK method",13,10,"$"
msg55	db "Testing int 13.5505 Seagate SCSI method",13,10,"$"
msg12	db "Testing int 13.12 Future Domain SCSI method",13,10,"$"

showCY:	pushf
	and dl,7fh	; simple status report. destroys registers.
	add dl,'0'
	mov [cs:diskmsg+9],dl
	mov dx,noerror
	popf
	jnc noCY
	mov dx,errmsg
noCY:	mov bx,ax
	mov cl,12
	shr bx,cl	; high nibble of AH to BX
	mov al,[hextab+bx]
	mov [statmsg],al
	mov bl,ah
	and bl,15	; low nibble of AH to BX
	mov al,[hextab+bx]
	mov [statmsg+1],al
	mov ah,9
	int 21h
	ret

noerror	db "No "
errmsg	db "error reported. Status: 0x"
statmsg	db "?? "
diskmsg	db "Disk: 0x80.",13,10,"$"
hextab	db "0123456789abcdef"
